<?php

/**
 * @file
 * Entity List Themer pages.
 */

/**
 * AJAX callback for pager.
 */
function entity_lister_pageturner_callback() {

  $list_class = $_POST['list_class'];

  // Is $list_class one of our allowed classes?
  if ('EntityLister' !== $list_class) {
    $allowed_classes = variable_get('entity_lister_allowed_classes', NULL);
    if (!in_array($list_class, $allowed_classes)) {
      print '';
      drupal_exit();
    }
  }

  $obj = new $list_class($_POST['config'], (int) $_POST['delta'], $_POST['flag'], $_POST['host_item']);
  $list = $obj->getList(urldecode($_POST['page']));
  $element = $obj->element($list);
  print drupal_render($element);

  drupal_exit();

}

/**
 * API Demo.
 *
 * See the constructor in EntityLister for documentation of config variables,
 * including some not used here.
 */
function entity_lister_demo() {

  $array['#attached'] = array(
    'css' => array(drupal_get_path('module', 'entity_lister') . '/demo.css'),
  );

  $array['heading'] = array(
    '#prefix' => '<h2>',
    '#markup' => t('Multiple Lists on One Page'),
    '#suffix' => '</h2>',
  );

  $array['summary'] = array(
    '#prefix' => '<p>',
    '#markup' => t("Depending on what's in your database, this demo page will
                   display up to three lists."),
    '#suffix' => '</p>',
  );

  $config['type'] = 'user';
  $config['numitems'] = '9';

  // Don't cache the list.
  $config['cache'] = '0';

  // '0' for no pager, '1' for standard pager, '2' for ajax pager.
  $config['pager'] = '2';

  // '0' for above, '1' for below, '2' for both.
  $config['pager_position'] = '1';

  // The $delta must be unique among all EntityListFieldList lists appearing
  // on this page, and must be an integer.
  $delta = 0;

  // All params are optional, but in this case we set $config and $delta.
  $obj = new EntityLister($config, $delta);

  // Passing the $page to getList() is only required when using the standard
  // pager. Since this list uses the AJAX pager, we could omit the
  // call, but it's here for demo purposes.
  $page = $obj->getPageNum();
  // Get the themed list output.
  $list = $obj->getList($page);
  // Place the list in a renderable element.
  $array['entity-lister-' . $delta] = $obj->element($list);

  // Another example.
  $config = array(
    'cache' => '1',
    'bundle' => array('article'),
    'numitems' => '1',
    'pager_st_offset' => '50',
    'get_total' => '1',
  );
  $delta = 1;
  $obj = new EntityLister($config, $delta);
  $list = $obj->getList();
  // The element() call is only necessary when you are using the AJAX pager,
  // but is a good idea regardless, for consistency's sake.
  $array['entity-lister-' . $delta] = $obj->element($list);

  // A third example.  Note that the config here is the same as above, but we
  // add a property condition and turn off caching.
  $config['propertycondition'][] = array(
    'column' => 'uid',
    'value' => 30,
    'operator' => '>',
  );
  $config['cache'] = '0';
  $delta = 2;
  $obj = new EntityLister($config, $delta);
  $list = $obj->getList();
  // The element() call is only necessary when you are using the AJAX pager,
  // but is a good idea regardless, for consistency's sake.
  $array['entity-lister-' . $delta] = $obj->element($list);

  return $array;

}
